/* YOODA : Yet another Object Oriented Database
   Copyright (C) 1994  Eric Abecassis

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */


/*****************************************************************************
*
*  MODULE :             function to manage sessions
*  SCOPE :              Implements session functions
*  FILE :               func.cc
*  AUTHORS :            E. Abecassis
*  CREATION DATE :      March 1, 1993
*  COPYRIGHTS :        (C) E. Abecassis, 1993
*  HISTORY :
*
******************************************************************************/

/* IMPORTS *******************************************************************/

/*=
Module Description
=*/

#include <iostream.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <stream.h>

#ifdef __GNUG__
#pragma implementation "dbvue_svc.hxx"
#endif


#ifndef __var_H
#include "var.h"
#endif
#ifndef __yooexcept_HXX
#include "yooexcept.hxx"
#endif
#ifndef __config_H
#include "config.h"
#endif
#ifndef __yoofunc_HXX
#include "yoofunc.hxx"
#endif
#ifndef __dbvue_HXX
#include "dbvue.hxx"
#endif
#ifndef __dbvue_svc_HXX
#include "dbvue_svc.hxx"
#endif
#ifndef __dbserver_HXX
#include "dbserver.hxx"
#endif


/*=
Module Description
=*/



/*= INTERNAL FUNCTION =======================================================*/
void yoo_server_connect(char* base, char* server) 
/*=
[DESCRIPTION :]
[DIAGNOSTIC :]
=*/
{
  yoo_env(base, 0) ;
  
  // Read 'repert.sys' information for the open database
  yoo_repert() ;

  YOO_DBServer = new DBServer(server) ;
  YOO_VirtualServer = NULL ;

  // Read DB configuration file
  yoo_config() ;

  if ((YOO_DBServer == NULL) || (YOO_DBServer->size() == 0)) {
    cerr << "Unknown server...exit" << endl ;
    exit(1) ;
  }
  
  YOO_DBServer->cleanLog() ;

  RemoteDBVue::MTTM_exec() ;
}


void option_error(char* name) 
{
  printf("usage: %s [-v] -b <basename> [-s <servername>]\n", name);
  exit(1) ;
}


void main(int argc, char** argv)
{
  char* base = NULL ;
  char* server = NULL ;
  int vers = 0 ;
  
  for (int i = 1; i < argc; i++) {
    if (strcmp(argv[i], "-b") == 0) {
      base = argv[i+1] ;
      i++ ;
    } else if (strcmp(argv[i], "-v") == 0) {
      vers = 1 ;
    } else if (strcmp(argv[i], "-s") == 0) {
      server = argv[i+1] ;
      i++ ;
    } else option_error(argv[0]) ;    
  }
  
  if (vers) {
    printf("YOODA version 1.2 <%s>, Copyright (C) 1994 Eric Abecassis
YOODA comes with ABSOLUTELY NO WARRANTY; for details type `COPYING'
in YOODA_HOME directory. This is free software, and you are welcome to 
redistribute it under certain conditions; for details read `COPYING'
or 'COPYING.LIB' in YOODA_HOME directory\n", argv[0]) ;
  }

  server = (server==NULL)?MONOUSER:server ;
  cerr << "Server <" << server << "> initialisation..." << endl ;
  
  yoo_server_connect(base, server) ;

}

